(function($) {
	var _data_picker_ = function(el, opts) {
			if (typeof(opts) != "object") {
				opts = {}
			}
			$.extend(this, DatePicker.DEFAULT_OPTS, opts);
			this.triger = $(el), this.bindMethodsToObj("show", "hide", "hideIfClickOutside", "selectDate"), this.build(), this.selectDate(), !this.draw && this.hide()
		};
	_data_picker_.DEFAULT_OPTS = {
		month_names: ["1月", "2月", "3月", "4月", "5月", "6月", "7月", "8月", "9月", "10月", "11月", "12月"],
		short_month_names: ["01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12"],
		short_day_names: ["日", "一", "二", "三", "四", "五", "六"],
		start_of_week: 0,
		day_click: !0,
		draw: !0,
		mindate: "",
		maxdate: "",
		complete: null,
		callback: null
	};
	_data_picker_.prototype = {
		build: function() {
			var t = this,
				nav = $('<div class="nav"><span class="prev"></span><span class="month-name"></span><span class="next"></span></div>'),
				tableShell = '<div class="calendar"><table><thead><tr>';
			this.navMonthName = $(".month-name", nav), this.navPrev = $(".prev", nav), this.navNext = $(".next", nav);
			this.navPrev.on("click", function() {
				if ($(this).hasClass("disable")) {
					return
				}
				t.moveMonthBy(-1)
			});
			this.navNext.on("click", function() {
				if ($(this).hasClass("disable")) {
					return
				}
				t.moveMonthBy(1)
			});
			$(this.adjustDays(this.short_day_names)).each(function() {
				tableShell += "<th>" + this + "</th>"
			});
			tableShell += "</tr></thead><tbody></tbody></table></div>";
			if (this.draw) {
				this.triger.append(nav, tableShell);
				this.dateSelector = this.rootLayers = this.triger
			} else {
				this.dateSelector = this.rootLayers = $('<div class="date-picker"></div>').append(nav, tableShell).insertAfter(this.triger)
			}
			this.tbody = $("tbody", this.dateSelector);
			$(this.tbody).on("click", ".selectable_day", function() {
				if(!this.day_click){
					return false;
				}
				var d = $(this);
				$(".active", t.tbody).removeClass("active"), d.addClass("active"), t.picked(d.attr("date"))
			})
		},
		selectMonth: function(date) {
			var t = this,
				mindate, minmonth, maxdate, maxmonth, newMonth = new Date(date.getFullYear(), date.getMonth(), 1);
			if (this.mindate) {
				mindate = this.stringToDate(this.mindate)
			}
			if (this.maxdate) {
				this.maxdate === true && (this.maxdate = this.dateToString(new Date())), maxdate = this.stringToDate(this.maxdate), maxmonth = new Date(maxdate.getFullYear(), maxdate.getMonth(), 1);
				newMonth < maxmonth ? this.navNext.removeClass("disable") : this.navNext.addClass("disable")
			}
			if (!this.currentMonth || !(this.currentMonth.getFullYear() == newMonth.getFullYear() && this.currentMonth.getMonth() == newMonth.getMonth())) {
				this.currentMonth = newMonth;
				var rangeStart = this.rangeStart(date),
					rangeEnd = this.rangeEnd(date),
					numDays = this.daysBetween(rangeStart, rangeEnd),
					dayCells = "";
				for (var i = 0; i <= numDays; i++) {
					var cellsCss = "",
						currentDay = new Date(rangeStart.getFullYear(), rangeStart.getMonth(), rangeStart.getDate() + i);
					if (this.isFirstDayOfWeek(currentDay)) {
						dayCells += "<tr>"
					}
					var d = currentDay.getDate();
					if (currentDay.getMonth() == date.getMonth()) {
						cellsCss = "selectable_day";
						if (maxdate && currentDay > maxdate) {
							cellsCss = "unselected_month"
						}
						if (mindate && currentDay < mindate) {
							cellsCss = "unselected_month"
						}
					} else {
						cellsCss = "unselected_month"
					};
					dayCells += '<td class="' + cellsCss + '" date="' + this.dateToString(currentDay) + '"><em>' + d + '</em></td>';
					if (this.isLastDayOfWeek(currentDay)) {
						dayCells += "</tr>"
					}
				};
				this.tbody.empty().append(dayCells);
				this.navMonthName.empty().append(this.currentMonth.getFullYear() + "年" + this.monthName(date));
				$('td[date="' + this.dateToString(new Date()) + '"]', this.tbody).addClass("today")
			};
			$(".active", this.tbody).removeClass("active");
			this.complete && this.complete(this)
		},
		selectDate: function(date) {
			var d = this.triger.prop("date");
			if (typeof(date) == "undefined" && typeof(d) != "undefined") {
				date = this.stringToDate(d)
			};
			!date && (date = new Date());
			this.selectedDate = date;
			this.selectedDateString = this.dateToString(this.selectedDate);
			this.selectMonth(this.selectedDate)
		},
		picked: function(d) {
			this.callback && this.callback(d, this), !this.draw && this.hide()
		},
		show: function() {
			this.rootLayers.css("display", "block");
			$([window, document.body]).click(this.hideIfClickOutside);
			this.triger.unbind("click", this.show);
			this.setPosition()
		},
		hide: function() {
			var me = this;
			this.rootLayers.css("display", "none");
			$([window, document.body]).unbind("click", this.hideIfClickOutside);
			this.triger.click(this.show)
		},
		hideIfClickOutside: function(event) {
			if (event.target != this.triger[0] && !this.insideSelector(event)) {
				this.hide()
			}
		},
		insideSelector: function(event) {
			var offset = this.dateSelector.position();
			offset.right = offset.left + this.dateSelector.outerWidth();
			offset.bottom = offset.top + this.dateSelector.outerHeight();
			return event.pageY < offset.bottom && event.pageY > offset.top && event.pageX < offset.right && event.pageX > offset.left
		},
		stringToDate: function(str) {
			var matches;
			if (matches = str.match(/^(\d{4,4})-([^\s]+)-(\d{1,2})$/)) {
				return new Date(matches[1], this.shortMonthNum(matches[2]), matches[3])
			} else {
				return null
			}
		},
		dateToString: function(date) {
			var d = date.getDate();
			if (d < 10) {
				d = "0" + d
			}
			return date.getFullYear() + "-" + this.short_month_names[date.getMonth()] + "-" + d
		},
		setPosition: function() {
			var offset = this.triger.offset();
			this.rootLayers.css({
				top: offset.top + this.triger.outerHeight(),
				left: offset.left
			})
		},
		moveMonthBy: function(amount) {
			var newMonth = new Date(this.currentMonth.getFullYear(), this.currentMonth.getMonth() + amount, this.currentMonth.getDate()),
				mindate = "",
				maxdate = "";
			if (this.mindate) {
				mindate = this.stringToDate(this.mindate)
			}
			if (this.maxdate) {
				maxdate = this.stringToDate(this.maxdate)
			}
			if (maxdate && newMonth > maxdate && (newMonth.getMonth() != maxdate.getMonth() || newMonth.getFullYear() != maxdate.getFullYear())) {
				return
			}
			if (mindate && newMonth < mindate && (newMonth.getMonth() != mindate.getMonth() || newMonth.getFullYear() != mindate.getFullYear())) {
				return
			}
			this.selectMonth(newMonth)
		},
		monthName: function(date) {
			return this.month_names[date.getMonth()]
		},
		bindToObj: function(fn) {
			var self = this;
			return function() {
				return fn.apply(self, arguments)
			}
		},
		bindMethodsToObj: function() {
			for (var i = 0; i < arguments.length; i++) {
				this[arguments[i]] = this.bindToObj(this[arguments[i]])
			}
		},
		indexFor: function(array, value) {
			for (var i = 0; i < array.length; i++) {
				if (value == array[i]) return i
			}
		},
		shortMonthNum: function(month_name) {
			return this.indexFor(this.short_month_names, month_name)
		},
		shortDayNum: function(day_name) {
			return this.indexFor(this.short_day_names, day_name)
		},
		daysBetween: function(start, end) {
			start = Date.UTC(start.getFullYear(), start.getMonth(), start.getDate());
			end = Date.UTC(end.getFullYear(), end.getMonth(), end.getDate());
			return (end - start) / 86400000
		},
		changeDayTo: function(dayOfWeek, date, direction) {
			var difference = direction * (Math.abs(date.getDay() - dayOfWeek - (direction * 7)) % 7);
			return new Date(date.getFullYear(), date.getMonth(), date.getDate() + difference)
		},
		rangeStart: function(date) {
			return this.changeDayTo(this.start_of_week, new Date(date.getFullYear(), date.getMonth()), -1)
		},
		rangeEnd: function(date) {
			return this.changeDayTo((this.start_of_week - 1) % 7, new Date(date.getFullYear(), date.getMonth() + 1, 0), 1)
		},
		isFirstDayOfWeek: function(date) {
			return date.getDay() == this.start_of_week
		},
		isLastDayOfWeek: function(date) {
			return date.getDay() == (this.start_of_week - 1) % 7
		},
		adjustDays: function(days) {
			var newDays = [];
			for (var i = 0; i < days.length; i++) {
				newDays[i] = days[(i + this.start_of_week) % 7]
			};
			return newDays
		}
	};
	window.DatePicker = _data_picker_;
	$.fn.DatePicker = function(opts) {
		return this.each(function() {
			new DatePicker(this, opts)
		})
	}
})(window.Zepto);